<?php
namespace Controllers;

// Контроллер работы с API Агорты
class Api extends Controller {

	public function __construct() {
		parent::__construct();
		$api_data=$this->controller->get_api_config();
		$this->model=new \Models\Api($this->f3, $api_data['domen'], $api_data['pass'], $api_data['store_id'], $api_data['count']);
	}

	// Установка СНО
	function sno() {
		$res['success']=true;
		$txt='';
		$this->db->exec('UPDATE synchronization SET time_start=?', time());
		$sno=$this->model->sno();
		if($sno['success']) {
			$r=$this->db->exec("UPDATE fr_settings SET sno=?", $sno['sno']);
			if($r>=0) {
				$txt=$this->messeges->messege('save_successful')['txt'];
			}
		}
		else { // если ответ от сервера не успешный
			$txt='';
			foreach ($sno['error'] as $er) {
				$txt.=$er.'<br>';
			}
			$res['success']=false;
		}

		$res['txt']=$txt;
		$this->db->exec('UPDATE synchronization SET time_start=0');

		echo json_encode($res);
		exit();
	}

	// Функция синхронизации пользователей
	function users() {
		$res['success']=true;
		$res['reload']='.users_list';
		$res['close_all_window']=true;
		$txt='';
		$this->db->exec('UPDATE synchronization SET time_start=?', time());
		$users=$this->model->users(); // получаем пользователей
		if($users['success']) { // если все получили
			// Добавляем группы
			$this->db->exec('DELETE FROM usergroups');
			$g=new \Models\Usergroups($this->db, $this->f3);
			foreach ($users['usergroups'] as $group) {
				$group_res=$g->save_group($group);
				$mess=$this->messeges->messege($group_res['txt']);
				if(!$group_res['success']) { // Если ошибка, то добавляем к тексту сообщения
					$res['success']=$group_res['success'];
					$txt.='<span class="false">'.$group['title'].' - '.$mess['txt'].'</span><br>';
				}
			}

			// Добавляем пользователей
			$this->db->exec('DELETE FROM users');
			$this->db->exec('VACUUM');
			foreach ($users['users'] as $user) {
				$user_res=$this->users->save_user($user);
				$mess=$this->messeges->messege($user_res['txt']);
				if(!$user_res['success']) {  // Если ошибка, то добавляем к тексту сообщения
					$res['success']=$user_res['success'];
					$txt.='<span class="false">'.$user['name'].' - '.$mess['txt'].'</span><br>';
				}
			}

			if($txt=='') { // если текст сообщения еще не сформирован, то добавляем из последнего запроса
				$txt=$this->messeges->messege('success_users_synchronization')['txt'];
			}
		}
		else { // если ответ от сервера не успешный
			$txt='';
			foreach ($data['error'] as $er) {
				$txt.=$er.'<br>';
			}
			$res['success']=false;
		}

		$this->db->exec('UPDATE synchronization SET time_start=0, users_update=?', time());
		$res['txt']=$txt;
		echo json_encode($res);
		exit();
	}

	// Загрузка категорий и товаров
	function products_load($time_update=0) {
		$res['success']=true;
		$txt='';

		$data=$this->model->products($time_update); // загружаем продукты
		if($data['success']) {
			// Добавляем категории товаров
			$sql=array();
			$val=array();
			foreach ($data['categories'] as $cat) {
				$sql[]="INSERT OR REPLACE INTO productcategories (id, parent_id, title, date_delete, date_update) VALUES (?, ?, ?, ?, ?)";
				$val[]=array(
					$cat['id'],
					$cat['parent_id'],
					$cat['title'],
					$cat['date_delete'],
					$cat['date_update']
				);
				$time_update=$cat['date_update'];
			}
			if(!empty($sql)) {
				if(!$this->db->exec($sql, $val)) {
					$txt.='<br>'.$this->messeges->messege('db_error')['txt'];
				}
				sleep(1);
			}

			// Добавляем товары и штрих-коды
			$sql=array();
			$val=array();
			$bsql=array();
			$bval=array();
			foreach ($data['products'] as $prod) {
				$sql[]="INSERT OR REPLACE INTO products (id, code, title, short_title, category_id, stock, price, vat, vat_type, date_delete, date_update) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
				$val[]=array(
					$prod['id'],
					$prod['code'],
					$prod['title'],
					$prod['short_title'],
					$prod['category_id'],
					$prod['stock'],
					$prod['price'],
					$prod['vat'],
					$prod['vat_type'],
					$prod['date_delete'],
					$prod['date_update']
				);
				$time_update=$prod['date_update'];
				$barcodes=explode(',', $prod['barcodes']);
				if(!empty($barcodes)) {
					foreach ($barcodes as $barcode) {
						$bsql[]="INSERT OR REPLACE INTO barcodes (product_id, barcode) VALUES (?, ?)";
						$bval[]=array(
							$prod['id'],
							$barcode
						);
					}
				}

			}
			if(!empty($sql)) {
				if(!$this->db->exec($sql, $val)) {
					$txt.='<br>'.$this->messeges->messege('db_error')['txt'];
				}
				sleep(1);
			}
			if(!empty($bsql)) {
				if(!$this->db->exec($bsql, $bval)) {
					$txt.='<br>'.$this->messeges->messege('db_error')['txt'];
				}
			}

			// Если массивы с продуктами и категориями были не пустые, то надо продолжить
			if(count($data['categories'])>0 || count($data['products'])>0) {
				$time=time();
				$this->db->exec('UPDATE synchronization SET time_start=?, time_update=?', array($time, $time_update));
				$txt.='<br>'.$this->messeges->messege('update')['txt'];
				$res['next_step']=$time;
			}
			else {
				$txt='<br>'.$this->messeges->messege('save_successful')['txt'];
				$this->db->exec('UPDATE synchronization SET time_start=?, time_update=?', array(0, $time_update));
			}

			$res['txt']=$txt;
		}
		else { // Если произошла ошибка
			foreach ($data['error'] as $er) {
				$txt.=$er.'<br>';
			}
			$res['success']=false;
			$this->db->exec('UPDATE synchronization SET time_start=?, time_update=?', array(0, $time_update));
		}

		return $res;
	}

	// Загрузка обновленныйх категорий и товаров
	function products() {
		// Проверяем не запущена ли уже синхронизация.
		$sinch=$this->db->exec("SELECT * FROM synchronization WHERE time_start=0 OR time_start<".(time()-600)." LIMIT 1");
		if(!$sinch) {
			$res=array(
				'success'=>false,
				'txt'=>$this->messeges->messege('sync_is_already_running')['txt']
			);
		}
		else {
			$this->db->exec('UPDATE synchronization SET time_start=?', array(time()));
			$time_update=$sinch[0]['time_update'];
			$res=$this->products_load($time_update);
			if($this->f3->get('auto_sinch')) {
				$res['txt']=$this->messeges->messege('success_products_synchronization')['txt'];
			}
			$this->db->exec('UPDATE synchronization SET time_start=0');
		}

		echo json_encode($res);
		exit();
	}

	// Полная загрузка категорий и товаров
	function products_all() {
		$time_start=$this->f3->get('GET.time_start'); // Узнаем время запуска синхронизации
		if(!$time_start) $time_start=0; // если время не задано, то это начало синхронизации
		// Проверяем не запущена ли уже синхронизация.
		$sinch=$this->db->exec("SELECT * FROM synchronization LIMIT 1");
		if($sinch[0]['time_start']==$time_start || ($time_start==0 && $sinch[0]['time_start']<time()-600)) {
			if($time_start>0) { // Если синхронизация не только что началась, то время обновления берем из таблицы
				$time_update=$sinch[0]['time_update'];
			}
			else { // если синхронизация только что началась, то время обновления 0, чтобы получить все товары
				$time_update=0;
			}
			if($time_start==0) { // Если синхронизация только началась, то очищаем таблицы
				$this->db->exec('DELETE FROM productcategories');
				$this->db->exec('DELETE FROM products');
				$this->db->exec('DELETE FROM barcodes');
				$this->db->exec('VACUUM');
			}
			$this->db->exec('UPDATE synchronization SET time_start=?', array(time()));
			$res=$this->products_load($time_update);
		}
		else {
			$mess=$this->messeges->messege('sync_is_already_running');
			$res['txt']=$mess['txt'];
			$res['success']=false;
		}

		if($res['next_step']) {
			$res['next_step']='/api/products_all/?time_start='.$res['next_step'];
		}
		echo json_encode($res);
		exit();
	}

	// Отдаем чеки
	function tickets($json=true) {
		$sinch=$this->db->exec("SELECT * FROM synchronization LIMIT 1");
		if($sinch[0]['time_start']<time()-600) {
			$this->db->exec("UPDATE synchronization SET time_start=?", time());
			$time_update=$sinch[0]['tickets_update'];
			if(!$time_update)$time_update=0;
			$receipts=new \Models\Receipts($this->db, $this->f3);
			$tickets=$receipts->select_receipts(array('r.time>? AND type>0', $time_update), array('order'=>'r.time'));
			if($tickets) {
				$res=$this->model->tickets($tickets);
				$n=count($tickets)-1;
				$tickets_update=$tickets[$n]['time'];
				if($res['success']) {
					$res['txt']=$this->messeges->messege('save_successful')['txt'];
					$this->db->exec("UPDATE synchronization SET time_start=0, tickets_update=?", $tickets_update);
				}
				else {
					foreach ($res['error'] as $er) {
						$txt.=$er.'<br>';
					}
					$res['txt']=$txt;
					$res['success']=false;
					if($res['noupdate']) {
						$this->db->exec("UPDATE synchronization SET time_start=0");
					}
					else {
						$this->db->exec("UPDATE synchronization SET time_start=0, tickets_update=?", $tickets_update);
					}
				}
			}
			else {
				$res=array(
					'success'=>true,
					'txt'=>$this->messeges->messege('save_successful')['txt']
				);
				$this->db->exec("UPDATE synchronization SET time_start=0, tickets_update=?", $tickets_update);
			}
			if($this->f3->get('auto_sinch')) {
				$res['txt']=$this->messeges->messege('tickets_users_synchronization')['txt'];
			}
		}
		else {
			$mess=$this->messeges->messege('sync_is_already_running');
			$res['txt']=$mess['txt'];
			$res['success']=false;
		}
		if($json) {
			echo json_encode($res);
			exit();
		}
	}

	// Авто синхронизация
	function auto() {
		$sinch=$this->db->exec("SELECT * FROM synchronization WHERE time_start=0 OR time_start<".(time()-600)." LIMIT 1");
		if(!$sinch) {
			$res=array(
				'success'=>false,
				'txt'=>$this->messeges->messege('sync_is_already_running')['txt']
			);
		}
		elseif($sinch[0]['auto_sinch']<0) {
			return;
		}
		elseif($sinch[0]['auto_sinch']>time()-$this->f3->get('synchronization_timer')*60) {
			$res=array(
				'success'=>false,
				'txt'=>$this->messeges->messege('no_synchronization_required')['txt']
			);
		}
		else {
			$this->db->exec("UPDATE synchronization SET auto_sinch=?", time());
			$this->f3->set('auto_sinch', 1);
			if($sinch[0]['users_update']<time()-3600) {
				$this->users();
			}
			elseif($sinch[0]['tickets_update']<time()-300) {
				$this->tickets();
			}
			$this->products();
		}

		echo json_encode($res);
		exit();
	}
}